
#define IOCTL_DBG
#define SUBFRAGMENT

#ifdef SUBFRAGMENT
#define SLAB_SUBFRAGMENT	0x100 /* decouple blockSampleSize from fragemnts */
#define SLAB_SUBF_IOCTL		0x2000 /* Allow subfragment to use old ioctl()s */
#endif

#define DEV_NAME_LEN	128
#define ALGO_COUNT		16

#ifndef SLAB_NRDEVICES
#define SLAB_NRDEVICES	SOUND_MIXER_NRDEVICES
#define SLAB_DEVICE_LABELS	SOUND_DEVICE_LABELS
#endif

#define ALL_CAPABILITIES(x) \
	(audioDev->stereoCaps | audioDev->monoCaps)

#ifndef MAX_DEVICES
#define MAX_DEVICES		8
#endif

#define	SLAB_RDONLY			11 /* 0xB */
#define SLAB_WRONLY			12 /* 0xC */
#define SLAB_FULL_DUPLEX	13 /* 0xD */
#define SLAB_HALF_DUPLEX	14 /* 0xE */
#define SLAB_FLAG_MASK		0x0f

#ifndef MIX_C_GO_DUPLEX
#define MIX_C_GO_DUPLEX	5	/* start pre-load from current location */
#endif

#define SLAB_NO_CONTROLS	0x10 /* prevent /dev/audio or /dev/audioctl ioctl */
/* SB_DUPLEX has taken the 0x20 flag position */
#define SLAB_8_BIT_IN		0x40 /* For general convergence options */
#define SLAB_8_BIT_OUT		0x80 /* For general convergence options */
#ifdef SUBFRAGMENT
#define SLAB_SUBFRAGMENT	0x100 /* decouple blockSampleSize from fragemnts */
#define SLAB_SUBF_IOCTL		0x2000 /* Allow subfragment to use old ioctl()s */
#endif
#ifdef IOCTL_DBG
#define SLAB_AUDIODBG	0x200 /* For ioctl() debug info */
#endif
#define SLAB_FDUP		0x400 /* For ioctl() debug info */

#ifdef SB_ONR
#define SLAB_NO_ONR	1
#define SLAB_1_BIT_ONR	2
#define SLAB_2_BIT_ONR	3
#define SLAB_3_BIT_ONR	4
#define SLAB_MAX_ONR	4
#endif

#define SLAB_MM_BIT			0x100000
#define SLAB_OPCODE_BIT		0x200000

#define SLAB_SPECIAL		0x400001

#define	SLAB_MM_MASK		~SLAB_MM_BIT
#define SLAB_OPCODE_MASK	~SLAB_OPCODE_BIT

#define SLAB_MM_CD			SLAB_VOL_CD | SLAB_MM_BIT
#define SLAB_MM_MIC			SLAB_VOL_MIC | SLAB_MM_BIT
#define SLAB_MM_LINE		SLAB_VOL_LINE | SLAB_MM_BIT
#define SLAB_MM_LINE1		SLAB_VOL_LINE1| SLAB_MM_BIT
#define SLAB_MM_LINE2		SLAB_VOL_LINE2| SLAB_MM_BIT
#define SLAB_MM_LINE3		SLAB_VOL_LINE3| SLAB_MM_BIT
#define SLAB_MM_SYNTH		SLAB_VOL_SYNTH | SLAB_MM_BIT
#define SLAB_MM_PCM			SLAB_VOL_PCM | SLAB_MM_BIT

/*
 * These should be MIX_C_GO_???
 */
#define ADIOD_INPUT			11
#define ADIOD_OUTPUT		12
#define ADIOD_DUPLEX		13

/*
 * This should be set up according to system type.
 */
#ifdef linux
#define SLAB_NULL			-1
#define SLAB_TREBLE			SOUND_MIXER_TREBLE
#define SLAB_MID			-1
#define SLAB_BASS			SOUND_MIXER_BASS
#define SLAB_INPUT_GAIN		SOUND_MIXER_IGAIN
#define SLAB_OUTPUT_GAIN	SOUND_MIXER_OGAIN
#define SLAB_VOLUME			SOUND_MIXER_VOLUME
#define SLAB_VOL_SYNTH		SOUND_MIXER_SYNTH
#define SLAB_VOL_CD			SOUND_MIXER_CD
#define SLAB_VOL_MIC		SOUND_MIXER_MIC
#define SLAB_VOL_LINE		SOUND_MIXER_LINE
#define SLAB_VOL_LINE1		SOUND_MIXER_LINE1
#define SLAB_VOL_LINE2		SOUND_MIXER_LINE2
#define SLAB_VOL_LINE3		SOUND_MIXER_LINE3
#define SLAB_VOL_PCM		SOUND_MIXER_PCM
#define SLAB_VOL_SPEAKER	SOUND_MIXER_SPEAKER
#define SLAB_VOL_ALT_PCM	SOUND_MIXER_ALTPCM
#define SLAB_VOL_RECLEV		SOUND_MIXER_RECLEV
#define SLAB_VOL_IMIX		SOUND_MIXER_IMIX

/*
#define SOUND_MIXER_NRDEVICES	17
#define SOUND_MIXER_VOLUME	0
#define SOUND_MIXER_BASS	1
#define SOUND_MIXER_TREBLE	2
#define SOUND_MIXER_SYNTH	3
#define SOUND_MIXER_PCM		4
#define SOUND_MIXER_SPEAKER	5
#define SOUND_MIXER_LINE	6
#define SOUND_MIXER_MIC		7
#define SOUND_MIXER_CD		8
#define SOUND_MIXER_IMIX	9	/*  Recording monitor 
#define SOUND_MIXER_ALTPCM	10
#define SOUND_MIXER_RECLEV	11	/* Recording level 
#define SOUND_MIXER_IGAIN	12	/* Input gain 
#define SOUND_MIXER_OGAIN	13	/* Output gain
#define SOUND_MIXER_LINE3	16	/* Input source 3  (line)
*/

#define SLAB_CD			SLAB_VOL_CD
#define SLAB_MIC		SLAB_VOL_MIC
#define SLAB_LINE		SLAB_VOL_LINE
#define SLAB_LINE1		SLAB_VOL_LINE1
#define SLAB_LINE2		SLAB_VOL_LINE2
#define SLAB_LINE3		SLAB_VOL_LINE3
#define SLAB_SYNTH		SLAB_VOL_SYNTH
#define SLAB_PCM		SLAB_VOL_PCM

#define SLAB_NULL_MASK			0
#define SLAB_TREBLE_MASK		1<<SLAB_TREBLE
#define SLAB_MID_MASK			SLAB_NULL_MASK
#define SLAB_BASS_MASK			1<<SLAB_BASS
#define SLAB_INPUT_GAIN_MASK	1<<SLAB_INPUT_GAIN
#define SLAB_OUTPUT_GAIN_MASK 	1<<SLAB_OUTPUT_GAIN
#define SLAB_VOLUME_MASK		1<<SLAB_VOLUME
#define SLAB_VOL_SYNTH_MASK		1<<SLAB_VOL_SYNTH
#define SLAB_VOL_CD_MASK		1<<SLAB_VOL_CD
#define SLAB_VOL_MIC_MASK		1<<SLAB_VOL_MIC
#define SLAB_VOL_LINE_MASK		1<<SLAB_VOL_LINE
#define SLAB_VOL_LINE1_MASK		1<<SLAB_VOL_LINE1
#define SLAB_VOL_LINE2_MASK		1<<SLAB_VOL_LINE2
#define SLAB_VOL_LINE3_MASK		1<<SLAB_VOL_LINE3
#define SLAB_VOL_PCM_MASK		1<<SLAB_VOL_PCM

#define SLAB_REC_SRC	SOUND_MIXER_RECSRC

#else ifdef SUN
#define SLAB_NRDEVICES	2

#define SLAB_DEVICE_LABELS	{"mic", "line"}

#define SLAB_NULL		-1
#define SLAB_TREBLE		0
#define SLAB_MID		-1
#define SLAB_BASS		1
#define SLAB_INPUT_GAIN	2
#define SLAB_OUTPUT_GAIN 3
#define SLAB_VOLUME		4
#define SLAB_VOL_SYNTH	5
#define SLAB_VOL_CD		6
#define SLAB_VOL_MIC	7
#define SLAB_VOL_LINE	8
#define SLAB_VOL_LINE1	9
#define SLAB_VOL_LINE2	10
#define SLAB_VOL_LINE3	11
#define SLAB_VOL_PCM	12

#define SLAB_CD			SLAB_VOL_CD
#define SLAB_MIC		SLAB_VOL_MIC
#define SLAB_LINE		SLAB_VOL_LINE
#define SLAB_LINE1		SLAB_VOL_LINE1
#define SLAB_LINE2		SLAB_VOL_LINE2
#define SLAB_LINE3		SLAB_VOL_LINE3
#define SLAB_SYNTH		SLAB_VOL_SYNTH
#define SLAB_PCM		SLAB_VOL_PCM

#define SLAB_NULL_MASK			0
#define SLAB_TREBLE_MASK		SLAB_NULL_MASK
#define SLAB_MID_MASK			SLAB_NULL_MASK
#define SLAB_BASS_MASK			SLAB_NULL_MASK
#define SLAB_INPUT_GAIN_MASK	SLAB_NULL_MASK
#define SLAB_OUTPUT_GAIN_MASK 	SLAB_NULL_MASK
#define SLAB_VOLUME_MASK		1<<SLAB_VOLUME
#define SLAB_VOL_SYNTH_MASK		SLAB_NULL_MASK
#define SLAB_VOL_CD_MASK		SLAB_NULL_MASK
#define SLAB_VOL_MIC_MASK		1<<SLAB_MIC
#define SLAB_VOL_LINE_MASK		1<<SLAB_LINE
#define SLAB_VOL_LINE1_MASK		SLAB_NULL_MASK
#define SLAB_VOL_LINE2_MASK		SLAB_NULL_MASK
#define SLAB_VOL_LINE3_MASK		SLAB_NULL_MASK
#define SLAB_VOL_PCM_MASK		SLAB_NULL_MASK

#define SLAB_REC_SRC	15

#endif /* linux/SUN definitions */

typedef int (*mixAlgo)();

typedef struct CAlgo {
	mixAlgo algo;
	short factor;
	short pad1;
} cAlgo;

typedef struct DuplexDev {
	int PID;			/* Analogue/Digital Input/Output Daemon */
	int BufferKey;		/* SHMEM Key */
	char *IBuffer;		/* analogue input buffer */
	int IBufferSize;	/* analogue output buffer size */
	int IBufferID;
	int ISegmentSize;	/* size of analogue output segments */
	char *OBuffer;		/* analogue output buffer */
	int OBufferSize;	/* analogue output buffer size */
	int OBufferID;
	int OSegmentSize;	/* size of analogue output segments */
	int OWorkSpaceSize;	/* For output fragmentation */
	/*
	 * PWrite is for mixengined to adiod. CRead is for adiod from mixengined
	 * to audio device.
	 */
	int PWriteBytes;	/* how much data written to buffer by parent */
	int CWriteBytes;	/* how much data written to device by adiod */
	char *PWrite;		/* where the engine is currently mixed to */
	char *CRead;		/* from where the adiod process is audio outing */
	char *mainPWrite;	/* Where the main mix is, regarding bus return mix */
	int mainPWriteBytes;	/* Counter of where the main mix is */
	int UnderRunCount;	/* Parent cannot provide data in time for write */
	/*
	 * CWrite is adiod into diskBuffer. PRead is mixiod into disk data file.
	 * The window mechanism of Bytes count is used to allow mixiod to determine
	 * how much data from this adiod can be synchronised to disk.
	 */
	int CReadBytes;		/* how much data read from device by adiod */
	int PReadBytes;		/* how much data read from buffer by mixiod */
	int realReadBytes;	/* how much data really read from device by adiod */
	char *PRead;		/* where the data is currently saved from */
	char *CWrite;		/* where the adiod process is audio inning */
	int OverRunCount;	/* Parent cannot clear out read audio data */
	int recordOffset1;
	int recordOffset2;
	int track1;
	int track2;
	int fd;				/* output process file descriptor */
	int fd2;			/* input process file descriptor */
	int mixerFD;		/* mixer device file descriptor */
	mixAlgo inputAlgorithm[ALGO_COUNT];
	mixAlgo outputAlgorithm[ALGO_COUNT];
	char devName[DEV_NAME_LEN];	/* output process file name */
	char mixerName[DEV_NAME_LEN];	/* mixer file name */
	int stereoCaps;
	int monoCaps;
	int recordCaps;
	int genCaps;
	int	cflags; 		/* configured RDONLY, WRONLY, HALF/FULL_DUPLEX */
	int	flags; 			/* active RDONLY, WRONLY, HALF_DUPLEX, FULL_DUPLEX */
	int readSampleRate;	/* For the physical device */
	int writeSampleRate;/* For the physical device */
	/*
	 * for altering analogue device parameters (4Front OSS stuff).
	 */
	int paramID;
	short paramValueLeft;
	short paramValueRight;
	int Command;		/* output operation to be executed */
	int OpState;	/* output operation to be executed */
	int status;			/* adiod operational status */
	u_long SleepPeriod;
	int inputLMax;
	int inputLAve;
	int inputRMax;
	int inputRAve;
	int outputLMax;
	int outputLAve;
	int outputRMax;
	int outputRAve;
	short d1;
	short d2;
	int inIndex;	/* Will be used to determine current read slippage */
	int outIndex;	/* Will be used to determine current read index */
	int inAdjust;	/* Defines the number of samples to slip on input */
	int fragSize;
	int fragIndexSave;
	int fragOutIndexSave;
	char *fragBuf;
	int skipCount;
	int skipFlag;
	/*
	 * Input noise reduction params
	trackparams inRp[2];
	 */
	int preLoad;
	int masterFloatAlgoLeft[MAX_DEVICES]; /* MAXDEVS is incorrect, there's no */
	int masterFloatAlgoRight[MAX_DEVICES];/* relationship, it is just a count */
	int lDeltaOut;
	int rDeltaOut;
	int lOldOut;
	int rOldOut;
	int lDeltaIn;
	int rDeltaIn;
	int lOldIn;
	int rOldIn;
} duplexDev;

